import os,sys
from wxPython.wx import *
from tuxmathscrabble.Environment import *

class Login:
	
	def __init__(self,parent):
		self.parent=parent
		self.size=wxSize(300,200)
		self.x=wxDialog(self.parent,wxNewId(),"TuxMathScrabble Login",size=self.size)
		self.x.Centre()
		
	def login(self):
	
		x=self.x
		size=self.size
		xc=size[0]/2
		yc=size[1]/2
		
		wtot=150
		wlabel=int(.5*wtot)
		wlogin=int(.5*wtot)
		hlabel=20
		hlogin=20
		
		xlabel=xc-wlabel
		ylabel=yc-hlabel
		xlogin=xc
		ylogin=ylabel
		
		wloginb=60
		hloginb=30
		xloginb=xc-wloginb-wloginb/2
		yloginb=ylogin+3*hlogin
		
		wexit=wloginb
		hexit=hloginb
		xexit=xc-wloginb/2
		yexit=yloginb

		wcancel=wloginb
		hcancel=hloginb
		xcancel=xc+wloginb/2
		ycancel=yloginb

		ulabel=wxStaticText(x,wxNewId(),"username",pos=wxPoint(xlabel,ylabel),size=wxSize(wlabel,hlabel))
		plabel=wxStaticText(x,wxNewId(),"password",pos=wxPoint(xlabel,ylabel+hlabel),size=wxSize(wlabel,hlabel))
		self.ufield=wxTextCtrl(x,wxNewId(),"",pos=wxPoint(xlogin,ylogin),size=wxSize(wlogin,hlogin),style=0)
		passID=wxNewId()
		self.pfield=wxTextCtrl(x,passID,"",pos=wxPoint(xlogin,ylogin+hlogin),size=wxSize(wlogin,hlogin),style=wxTE_PASSWORD|wxTE_PROCESS_ENTER)
		EVT_TEXT_ENTER(self.pfield,passID,self.validate)

		xid=wxNewId()
		loginButton=wxButton(x,xid,"Login",pos=wxPoint(xloginb,yloginb),size=wxSize(wloginb,hloginb))
		EVT_BUTTON(loginButton, xid, self.validate)

		xid=wxNewId()
		exitButton=wxButton(x,xid,"Quit",pos=wxPoint(xexit,yexit),size=wxSize(wexit,hexit))
		EVT_BUTTON(exitButton, xid, self.quitCB)

		xid=wxNewId()
		cancelButton=wxButton(x,xid,"Cancel",pos=wxPoint(xcancel,ycancel),size=wxSize(wcancel,hcancel))
		EVT_BUTTON(cancelButton, xid, self.cancelCB)

		x.Centre()
		self.ufield.SetFocus()
		self.ufield.SetFocus()
		self.ufield.SetFocus()
		rval=x.ShowModal()
		
		if rval==0:
			return None
		elif rval==2:
			return 'cancel'
		else:
			return(self.ufield.GetValue())
		
			
	def quitCB(self,e):
		self.x.Destroy()
		sys.exit()
	
	def cancelCB(self,e):
		self.x.EndModal(2)
			
	def validate(self,e):
		valid=0
		name_submission=self.ufield.GetValue()
		password_submission=self.pfield.GetValue()
		if name_submission=='new':return
		
		try:
			if not os.path.exists(userdir):
				self.x.EndModal(valid)
				return
			if not os.listdir(userdir).count(name_submission):
				self.x.EndModal(valid)
				return
		except:
			self.x.EndModal(valid)
			
		infname=os.path.join(userdir,name_submission,'config')
		inf=open(infname)
		cfg=eval(inf.read())
		inf.close()
		if cfg.has_key('password'):
			if cfg['password']==password_submission:valid=1
		
		self.x.EndModal(valid)
