#!/usr/bin/python

from thread import *
import os, pygame,sys,pickle,time,thread
from random import random
from pygame.locals import *

import sys,pickle,os,string,time,filecmp,copy
from string import *
from wxPython.wx import *
from wxPython.html import *
from wxPython.grid import *
from wxPython.lib.imagebrowser import *
from wx.lib.editor.editor import Editor
from tuxmathscrabble.Environment import *

"""
This class accesses/edits the config in self.name directory.
"""

class Template:

	def __init__(self,parent,name):
		#print 'Template',name
		self.parent=parent
		self.name=name
		self.p=None
		self.ed=None
		
	def get_installed(self):
		fnames=os.listdir(os.path.join(configdir,self.name))
		rnames=[]
		for f in fnames:
			if string.find(f,'.')<0:
				rnames.append(f)
		return rnames
	
	def edit_target(self,e):
		self.ed.Clear()
		target=self.combo_box.GetValue()
		if target=='':return
		infname=os.path.join(configdir,self.name,target,'config')
		inf=open(infname)
		lines=inf.readlines()
		inf.close()
		cfg=""
		for line in lines:cfg="%s%s"%(cfg,line)
		self.ed.WriteText(cfg)
		
	def reload(self,name):
		self.combo_box.Clear()
		installed=self.get_installed()
		for idx in range(len(installed)):
			self.combo_box.Append(installed[idx])
		self.combo_box.SetValue(name)
		self.edit_target(None)
	
				
	def setup(self,p):
		self.p=p
		
		installed=self.get_installed()

		#psize=p.GetSize()
		psize=(800,600)
		p.SetSize(psize)
		xc=psize[0]/2
		yc=psize[1]/2
		
		wcombo=175
		hcombo=30
		xcombo=xc-wcombo
		ycombo=10
		self.wcombo=wcombo
		self.hcombo=hcombo
		self.xcombo=xcombo
		self.ycombo=ycombo
		
		wsave=wcombo
		hsave=30
		xsave=xcombo
		ysave=ycombo+40
		
		wdelete=wcombo
		hdelete=30
		xdelete=xcombo
		ydelete=ycombo+40

		wlogout=wcombo
		hlogout=30
		xlogout=xcombo+wcombo
		ylogout=ycombo+40
		
		xeditor=0
		yeditor=30
		weditor=800
		heditor=800
		
		#layout the admin panel:
		hbox = wxBoxSizer(wxHORIZONTAL)
		box = wxBoxSizer(wxVERTICAL)
		
		#combo user select
		self.comboID=wxNewId()
		installed=self.get_installed()
		self.combo_box=wxComboBox(p,self.comboID,"",pos=wxPoint(xcombo,ycombo),size=wxSize(wcombo,hcombo),choices=installed)
		EVT_TEXT(p,self.comboID,self.edit_target)
		
		
		#save button
		xid=wxNewId()
		b1=wxButton(p,xid,"Save",pos=wxPoint(xsave,ysave),size=wxSize(wsave,hsave))
		EVT_BUTTON(self.p, xid, self.saveCB)

		#delete button
		xid=wxNewId()
		b2=wxButton(p,xid,"Delete",pos=wxPoint(xdelete,ydelete),size=wxSize(wdelete,hdelete))
		EVT_BUTTON(self.p, xid, self.deleteCB)
		
		#logout button
		xid=wxNewId()
		b3=wxButton(p,xid,"Logout",pos=wxPoint(xlogout,ylogout),size=wxSize(wlogout,hlogout))
		EVT_BUTTON(self.p, xid, self.logoutCB)

		#user editor
		#self.ed = wxEditor(p,wxNewId(), pos=wxPoint(xeditor,yeditor),size=wxSize(weditor,heditor),style=wxSUNKEN_BORDER)
		#print self.ed.GetMaxSize(), self.ed.GetSize(),self.ed.GetRange()
		self.ed=wxTextCtrl(p,wxNewId(),style=wxTE_MULTILINE|wxTE_RICH2|wxSUNKEN_BORDER)
		#print dir(self.ed)
		
		hbox.Add(self.combo_box, 0, 0, 1)
		hbox.Add(b1, 0, 0, 1)
		hbox.Add(b2, 0, 0, 1)
		hbox.Add(b3, 0, 0, 1)
		
		box.Add(hbox,0,wxALIGN_CENTER,1)
		box.Add(self.ed, 1, wxEXPAND, 1)
		
		p.SetSizer(box)
		#p.SetAutoLayout(True)
		
		self.p=p
		
		
		

	def deleteCB(self,e):
		d=eval(self.ed.GetValue())
		if d['name']=='new':return
		if d['name']=='admin':return
		fname=os.path.join(userdir,d['name'])
		try:os.removedirs(fname)
		except:pass#print 'unable to recursively delete 1x',fname
		try:
			cmd="rm -rf %s"%(fname)
			os.system(cmd)
		except:pass#print 'unable to recursively delete 2x',fname
		self.reload("")
	
	def saveCB(self,e):
		d=eval(self.ed.GetValue())
		oufdir=os.path.join(configdir,self.name,d['name'])
		if not os.path.exists(oufdir):
			os.mkdir(oufdir)
		oufname=os.path.join(oufdir,'config')
		ouf=open(oufname,'w')
		ouf.write(self.ed.GetValue())
		ouf.close()
		self.reload(d['name'])
		
		
	def logoutCB(self,e):
		self.parent.EndModal(0)
		
