#!/usr/bin/python

import os,string,math,random,time,pickle,sys
from pygame.locals import *
from random import random
from tuxmathscrabble.myutil import *
from tuxmathscrabble.Environment import *



class GridCell:
	def __init__(self,rr,cc,mm,nn,infname,piece,complete):
		self.row=rr
		self.col=cc
		self.M=mm
		self.N=nn
		self.ptype=rr
		self.level=cc
		self.complete=complete
		self.infname=infname
		self.piece=piece
		
		self.surf=None
		self.highlight=None
		
		
	def set_complete(self,val):
		self.complete=val

	def unload(self):
		self.surf=None
		
	def load_once(self,hc):
		
		surf,surf_rect=load_image(self.infname)
		hilight,hilight_rect=load_image(self.infname)
		hilight.fill(hc)
		
		surf.set_clip(self.piece)
		hilight.set_clip(self.piece)
		
		self.surf=surf
		self.hilight=hilight
		#print surf_rect
		
	def render(self,main,hi):
		#reverse these?
		if hi:surf=self.surf
		else:return
		#elif self.complete:surf=self.surf
		#else:surf=self.surf
		surf_rect=surf.get_rect()
		xc=main.screen.get_size()[0]/2
		yc=main.screen.get_size()[1]/2
		
		xoffset=xc-(self.N*surf_rect[2])/2
		yoffset=yc-(self.M*surf_rect[3])/2
		
		tlcx=xoffset+self.col*surf_rect[2]
		tlcy=yoffset+self.row*surf_rect[3]
		main.screen.blit(surf,(tlcx,tlcy),surf.get_clip())
		
